com.google.cloud.dataflow.sdk.values

## Interface PInput

All Known Subinterfaces:
  PCollectionView<T>, PValue

All Known Implementing Classes:
  KeyedPCollectionTuple, PBegin, PCollection, PCollectionList, PCollectionTuple, PValueBase, TypedPValue

    public interface PInput

The interface for things that might be input to a `PTransform`.

### Method Summary

All Methods Instance Methods Abstract Methods
`Collection<? extends PValue>` `expand()` Expands this `PInput` into a list of its component output `PValues`.
`void` `finishSpecifying()` After building, finalizes this `PInput` to make it ready for being used as an input to a `PTransform`.
`Pipeline` `getPipeline()` Returns the owning `Pipeline` of this `PInput`.

### Method Detail

#### getPipeline

    Pipeline getPipeline()

Returns the owning `Pipeline` of this `PInput`.

#### expand

    Collection<? extends PValue> expand()

Expands this `PInput` into a list of its component output `PValues`.

- A `PValue` expands to itself.
- A tuple or list of `PValues` (such as `PCollectionTuple` or `PCollectionList`) expands to its component `PValue PValues`.

Not intended to be invoked directly by user code.

#### finishSpecifying

    void finishSpecifying()

After building, finalizes this `PInput` to make it ready for being used as an input to a `PTransform`.

Automatically invoked whenever `apply()` is invoked on this `PInput`, so users do not normally call this explicitly.